
<div class="p-p-5 filter-shortcuts" >
    <div>
        <p-toggleButton 
            class="filter-shortcut"
            styleClass="filter-shortcut-all-none"
            [ngModel]="selectedIssueTypes.length == issueTypes.length"
            (click)="toggleAllIssueType()"
            onLabel="None" 
            offLabel="All"
        ></p-toggleButton>
        <button *ngFor="let issueType of issueTypes" 
            pButton 
            class="p-button-text filter-shortcut" 
            [class.filter-active]="isIssueTypeSelected(issueType.key)" 
            (click)="toggleIssueType(issueType.key)" 
            type="button" 
            [icon]="issueType.icon" 
            [label]="issueType.label"
        >
            <span pBadge *ngIf="calcIssueTypeCount(issueType.key) != 0" class="custom-badge" [value]="calcIssueTypeCount(issueType.key).toString()" severity="danger"></span>
        </button>
    </div>
    
    <div>
        <div class="p-buttonset d-flex justify-content-center">
          <button pButton icon="fa fa-chevron-left" (click)="prevMonth()" [disabled]="selectedMonth.getFullYear() === 2015"
        ></button>
          <button pButton disabled class="month-name-btn" [label]="selectedMonth.toLocaleString('en-US', { month: 'long', year: 'numeric' })"
          ></button>
          <button pButton icon="fa fa-chevron-right" (click)="nextMonth()" [disabled]="selectedMonth.getFullYear() === currentYear && selectedMonth.getMonth() === currentMonth"
        ></button>
        </div>
    </div>
</div>

<div class="p-mx-5 p-pb-5">
    <div class="loader-placeholder">
        <p-progressBar *ngIf="isLoading" mode="indeterminate" [style]="{'height': '3px'}"></p-progressBar>
    </div>
    <p-table [value]="issues" dataKey="index">
        <ng-template pTemplate="header">
            <tr>
                <th style="width: 2.25em"></th>
                <th  pSortableColumn="userFullName">Full Name <p-sortIcon field="userFullName"></p-sortIcon></th>
                <th  pSortableColumn="issueType">Issue Type <p-sortIcon field="issueType"></p-sortIcon></th>
                <th  pSortableColumn="reports.length">Count <p-sortIcon field="reports.length"></p-sortIcon></th>
                <th  pSortableColumn="hours">Internal/External Hours <p-sortIcon field="hours"></p-sortIcon></th>
            </tr>
        </ng-template>
        <ng-template pTemplate="body" let-expanded="expanded" let-issue>
            <tr>
                <td>
                    <div [pRowToggler]="issue">
                        <i [ngClass]="expanded ? 'fa fa-fw fa-chevron-down' : 'fa fa-fw fa-chevron-right'"></i>
                    </div>
                </td>    
                <td>{{issue.userFullName}}</td>
                <td>
                    <span [class]="'issue-type-' + issue.issueType">{{getIssueTypeLabel(issue.issueType)}}</span>
                </td>
                <td>{{issue.reports.length}}</td>
                <td *ngIf="!!issue.description">{{issue.description}} </td>
                <td *ngIf="!issue.description">{{issue.hours}} </td>
            </tr>
        </ng-template>
        <ng-template pTemplate="rowexpansion" let-issue>
            <tr>
                <td colspan="5">
                    <p-table [value]="issue.reports" dataKey="id" colspan>
                        <ng-template pTemplate="header">
                            <tr>
                                <th pSortableColumn="account.name">Account <p-sortIcon field="account.name"></p-sortIcon></th>
                                <th pSortableColumn="project.name">Project <p-sortIcon field="project.name"></p-sortIcon></th>
                                <th pSortableColumn="reportingDate">Date <p-sortIcon field="reportingDate"></p-sortIcon></th>
                                <th pSortableColumn="internalHours">Hours <p-sortIcon field="internalHours"></p-sortIcon></th>
                                <th>Description</th>
                            </tr>
                        </ng-template>
                        <ng-template pTemplate="body" let-report>
                            <tr>
                                <td>{{report.account.name}}</td>
                                <td>{{report.project.name}}</td>
                                <td>{{report.reportingDate | date:'MM/dd/YYYY'}}</td>
                                <td>{{report.internalHours}} / {{report.externalHours}}</td>
                                <td>{{report.workDescription}}</td>
                            </tr>
                        </ng-template>
                    </p-table>
                </td>
            </tr>
        </ng-template>
        <ng-template pTemplate="emptymessage">
            <tr>
                <td colspan="5">
                    <div class="progress-spinner-content">
                        <div class="my-auto">
                            <p-progressSpinner 
                                *ngIf="isLoading"
                                strokeWidth="6" 
                            ></p-progressSpinner>
                            <div *ngIf="!isLoading">There are no issues found</div>
                        </div>
                    </div>
                </td>
            </tr>
        </ng-template>
    </p-table>

</div>